<%@page import="CheckoutData"%>
<%@page import="java.sql.*"%>
<%@page import="java.text.*"%>
<%@page import="java.util.*"%>


<jsp:useBean id="checkoutParams" class="CheckoutData">
	<jsp:setProperty name="checkoutParams"
	 property="cid"
	 param="Cid"/>
	<jsp:setProperty name="checkoutParams"
	 property="username"
	 param="Username"/>
	<jsp:setProperty name="checkoutParams"
	 property="cname"
	 param="Cname"/>
	<jsp:setProperty name="checkoutParams"
	 property="address"
	 param="Address"/>
	<jsp:setProperty name="checkoutParams"
	 property="basket"
	 param="Basket"/>
	<jsp:setProperty name="checkoutParams"
	 property="card1"
	 param="Card1"/>
	<jsp:setProperty name="checkoutParams"
	 property="card2"
	 param="Card2"/>
	<jsp:setProperty name="checkoutParams"
	 property="card3"
	 param="Card3"/>
	<jsp:setProperty name="checkoutParams"
	 property="card4"
	 param="Card4"/>
	<jsp:setProperty name="checkoutParams"
	 property="card_month"
	 param="Card_month"/>
	<jsp:setProperty name="checkoutParams"
	 property="card_year"
	 param="Card_year"/>
	<jsp:setProperty name="checkoutParams"
	 property="retry"
	 param="Retry"/>
</jsp:useBean>


<%
	// Part 1: Retrieve Form Data from previous Form
	// and process basket data

	String cid = checkoutParams.getCid(), 
		username = checkoutParams.getUsername(),
		basket = checkoutParams.getBasket(),
		cname = checkoutParams.getCname(), address = checkoutParams.getAddress(),
		card1 = checkoutParams.getCard1(), card2 = checkoutParams.getCard2(),
		card3 = checkoutParams.getCard3(), card4 = checkoutParams.getCard4(),
		card = card1+"-"+card2+"-"+card3+"-"+card4,
		card_month = checkoutParams.getCard_month(),
		card_year = checkoutParams.getCard_year(),
		basketCookie = checkoutParams.getBasket();
	boolean basketContainsValidItem = false;

	// Convert the basket data from a string to two arrays
	ArrayList items = new ArrayList(0);
	ArrayList qtys = new ArrayList(0);
	String tempWord="";
	char tempChar;

	// We reference elements in the basket cookie as:
	//   "ISBN1,Qty1:ISBN2,Qty2:ISBN3,Qty3: ... etc for however
	// many unique elements are in the cookie
	for(int i=0; i<basketCookie.length(); i++) {
		tempChar = basketCookie.charAt(i);
		if((tempChar==',')||(tempChar==':')) {
			if(tempChar==',')
				items.add(tempWord);
			else
				qtys.add(tempWord);
			tempWord="";
		}
		else
			tempWord += tempChar;
	}


	// Part 2:  We present the user's order information
	// to them.

	if(checkoutParams.retry()) {

		// Display the HTML page header
		out.println("<HTML>");
		out.println("<TITLE>Step 4 - Confirm Order</TITLE>");
		out.println("<BODY>");
		out.println("<script language=\"javascript\" src=\"menu.js\"></script>");


		// Display Shipping and Billing Information
		out.println("<TABLE ALIGN =\"CENTER\" WIDTH=\"80%\"><TR><TD><H2>Step 4 - Confirm Order</H2></TD></TR></TABLE>");
		out.println("<CENTER><BR/><IMG SRC=\"images\\line2.jpg\"><BR/><BR/></CENTER>");
		out.println("<TABLE ALIGN =\"CENTER\" WIDTH=\"65%\"><TR><TD>Welcome, <B>"+username+"</B></TD></TR></TABLE>");
		out.println("<TABLE ALIGN =\"CENTER\" WIDTH=\"55%\"><TR><TD WIDTH=\"50%\">The order will be shipped to:</TD><TD><B>"+cname+"</B></TD></TR>");
		out.println("<TR><TD></TD><TD><B>"+address+"</B></TD></TR></TABLE><BR/>");
		out.println("<TABLE ALIGN=\"CENTER\" WIDTH=\"65%\"><TR><TD>Your credit card number is: <B>"+card+", "+card_month+"/"+card_year+"</B></TD></TR></TABLE><BR/>");


		// Display list of books ordered

		Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
		NumberFormat n = NumberFormat.getCurrencyInstance(Locale.US);
		double totalCost = 0;
		try {
	
			// We need to connect to the database to retrieve
			// each book's name and price
			Connection con = DriverManager.getConnection("jdbc:db2:bookshop","user","pass");
			Statement stmt = con.createStatement();
			boolean first = false;

			// For each unique book found:
			for(int i=0; i<items.size();i++) {

				// Then, retrieve individual book information
				// from the database
				String sql = "SELECT title, price FROM Books WHERE ISBN = '"+items.get(i)+"'";
				ResultSet rs = stmt.executeQuery(sql);

				if(rs.next()) {

					// ***This code is only being generated if at least
					// one book is found in the database matching
					// a book in the user's shopping basket***

	
					// Update total cost of all books variable
					double cost = rs.getDouble("price")*Integer.parseInt((String)qtys.get(i));
					totalCost += cost;


					// On the first book found only, add some form header info
					if(!first) {
						first = true;
						basketContainsValidItem = true;
						out.println("<CENTER><IMG SRC=\"images\\line2.jpg\"><BR/></CENTER>");
						out.println("<CENTER><TABLE WIDTH=\"62%\"><BR/>");
					}

					// Finally, present this information to the user as a form
					out.println("<TR><TD>"+rs.getString("title")+"</TD>");
					out.println("<TD><B>"+qtys.get(i)+"</B></TD>");
					out.println("<TD><B> x </B></TD>");
					out.println("<TD ALIGN=\"RIGHT\">"+n.format(rs.getDouble("price"))+"</TD>");
					out.println("<TD> = </TD>");
					out.println("<TD ALIGN=\"RIGHT\"> "+n.format(cost)+" </TD>");
					out.println("</TR>");
				}
				rs.close();
			}

			// We always close our database connection instances
			stmt.close();
			con.close();
		}
		catch(Exception e) {
			out.println(e.toString());
		}

		// Part 3A:  If at least one book from the user's
		// cookie matched a book in the database, we allow
		// the transaction to proceed and ask the user to
		// confirm their order.
	
		if(basketContainsValidItem) {

			// First, we display the tail of the book list
			out.println("</TABLE>");
			out.println("<BR/><CENTER><IMG SRC=\"images\\line2.jpg\"></CENTER><BR/><BR/>");
			out.println("<TABLE WIDTH=\"62%\"><TR>");
			out.println("<TD WIDTH=\"15%\"></TD>");
			out.println("<TD WIDTH=\"10%\" ALIGN=\"RIGHT\"><B>Total:</B></TD>");
			out.println("<TD WIDTH=\"4%\" ALIGN=\"RIGHT\">"+n.format(totalCost)+"</TD>");
			out.println("</TR></TABLE></CENTER>");


			// Then, we save form information and present a
			// confirmation button to the user
			out.println("<FORM NAME=\"CheckoutNext\" ACTION=\"submitorder.jsp\" METHOD=\"POST\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Cid\" VALUE=\""+cid+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Username\" VALUE=\""+username+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Cname\" VALUE=\""+cname+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Address\" VALUE=\""+address+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Basket\" VALUE=\""+basket+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Retry\" VALUE=\"true\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Card1\" VALUE=\""+card1+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Card2\" VALUE=\""+card2+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Card3\" VALUE=\""+card3+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Card4\" VALUE=\""+card4+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Card_month\" VALUE=\""+card_month+"\">");
			out.println("<INPUT TYPE=\"HIDDEN\" NAME=\"Card_year\" VALUE=\""+card_year+"\">");
			out.println("<CENTER><INPUT TYPE=\"Submit\" VALUE=\"Confirm Order\"></CENTER>");
			out.println("</FORM>");

			// Display the HTML page tail
			out.println("</BODY>");
			out.println("<script language=\"javascript\" src=\"footer.js\"></script>");
			out.println("</HTML>");
		}

		// Part 3B:  If no book was found in the database
		// matching any book in the user's shopping cart,
		// we alert them of an error.  This could happen
		// if a book is deleted from the database after the
		// user all ready adds it to their shopping cart

		else {
			// First, we display the tail of the book list
			out.println("<BR/><CENTER><IMG SRC=\"images\\line2.jpg\"></CENTER><BR/><BR/>");

			// Then, we tell the user there was an error		
			out.println("<TABLE WIDTH=\"62%\" ALIGN=\"CENTER\"><TR><TD WIDTH=\"15%\">");
			out.println("<H3>We're sorry, the books you were going to purchase are no longer available.  Please try again later</H3>");
			out.println("</TD></TR></TABLE></CENTER>");

			// Display the HTML page tail
			out.println("</BODY>");
			out.println("<script language=\"javascript\" src=\"footer.js\"></script>");
			out.println("</HTML>");


		}
	}

	// Part 4: If user attempts to access this JSP outside
	// the context of a form session, we display an error
	else 
		out.println("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=expiredform.html\">");
%>
